#include "stacktool.h"
#include "bdd_bitbit_sbr.h"

static int sbr_8_res_0_tmp_0 (void) {
  return bdd_op_inputs[16];
}

static int sbr_8_res_0_tmp_1 (void) {
  return bdd_op_inputs[17];
}

static int sbr_8_res_0_tmp_2 (void) {
  return bdd_op_inputs[18];
}

static int sbr_8_res_0_tmp_3 (void) {
  return bdd_op_inputs[19];
}

static int sbr_8_res_0_tmp_4 (void) {
  return bdd_op_inputs[20];
}

static int sbr_8_res_0_tmp_5 (void) {
  return bdd_op_inputs[21];
}

static int sbr_8_res_0_tmp_6 (void) {
  return bdd_op_inputs[22];
}

static int sbr_8_res_0_tmp_7 (void) {
  return bdd_op_inputs[23];
}

struct mem_loc_t bdd_bitbit_sbr_res (struct mem_loc_t in1, data_val_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2, bdd_op_inputs, 2 * 8);
  explode (0xff, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = (bdd_op_inputs[0] || sbr_8_res_0_tmp_0 ());
  // bitbit_01_0_8.bdd
  outputs[1] = (bdd_op_inputs[1] || sbr_8_res_0_tmp_1 ());
  // bitbit_02_0_8.bdd
  outputs[2] = (bdd_op_inputs[2] || sbr_8_res_0_tmp_2 ());
  // bitbit_03_0_8.bdd
  outputs[3] = (bdd_op_inputs[3] || sbr_8_res_0_tmp_3 ());
  // bitbit_04_0_8.bdd
  outputs[4] = (bdd_op_inputs[4] || sbr_8_res_0_tmp_4 ());
  // bitbit_05_0_8.bdd
  outputs[5] = (bdd_op_inputs[5] || sbr_8_res_0_tmp_5 ());
  // bitbit_06_0_8.bdd
  outputs[6] = (bdd_op_inputs[6] || sbr_8_res_0_tmp_6 ());
  // bitbit_07_0_8.bdd
  outputs[7] = (bdd_op_inputs[7] || sbr_8_res_0_tmp_7 ());
  // bitbit_08_0_8.bdd
  outputs[8] = (bdd_op_inputs[0] || (bdd_op_inputs[8]?bdd_op_inputs[24]:sbr_8_res_0_tmp_0 ()));
  // bitbit_09_0_8.bdd
  outputs[9] = (bdd_op_inputs[1] || (bdd_op_inputs[9]?bdd_op_inputs[25]:sbr_8_res_0_tmp_1 ()));
  // bitbit_10_0_8.bdd
  outputs[10] = (bdd_op_inputs[2] || (bdd_op_inputs[10]?bdd_op_inputs[26]:sbr_8_res_0_tmp_2 ()));
  // bitbit_11_0_8.bdd
  outputs[11] = (bdd_op_inputs[3] || (bdd_op_inputs[11]?bdd_op_inputs[27]:sbr_8_res_0_tmp_3 ()));
  // bitbit_12_0_8.bdd
  outputs[12] = (bdd_op_inputs[4] || (bdd_op_inputs[12]?bdd_op_inputs[28]:sbr_8_res_0_tmp_4 ()));
  // bitbit_13_0_8.bdd
  outputs[13] = (bdd_op_inputs[5] || (bdd_op_inputs[13]?bdd_op_inputs[29]:sbr_8_res_0_tmp_5 ()));
  // bitbit_14_0_8.bdd
  outputs[14] = (bdd_op_inputs[6] || (bdd_op_inputs[14]?bdd_op_inputs[30]:sbr_8_res_0_tmp_6 ()));
  // bitbit_15_0_8.bdd
  outputs[15] = (bdd_op_inputs[7] || (bdd_op_inputs[15]?bdd_op_inputs[31]:sbr_8_res_0_tmp_7 ()));
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

static int sbr_8_cc_0_tmp_0 (void) {
  return bdd_op_inputs[16];
}

static int sbr_8_cc_0_tmp_1 (void) {
  return (bdd_op_inputs[0] || sbr_8_cc_0_tmp_0 ());
}

static int sbr_8_cc_0_tmp_2 (void) {
  return bdd_op_inputs[31];
}

static int sbr_8_cc_0_tmp_3 (void) {
  return (bdd_op_inputs[0] || (bdd_op_inputs[8]?bdd_op_inputs[24]:sbr_8_cc_0_tmp_0 ()));
}

static int sbr_8_cc_0_tmp_4 (void) {
  return bdd_op_inputs[23];
}

static int sbr_8_cc_0_tmp_5 (void) {
  return (bdd_op_inputs[7] || sbr_8_cc_0_tmp_4 ());
}

static int sbr_8_cc_0_tmp_6 (void) {
  return (bdd_op_inputs[22] || sbr_8_cc_0_tmp_5 ());
}

static int sbr_8_cc_0_tmp_7 (void) {
  return (bdd_op_inputs[6] || sbr_8_cc_0_tmp_6 ());
}

static int sbr_8_cc_0_tmp_8 (void) {
  return (bdd_op_inputs[21] || sbr_8_cc_0_tmp_7 ());
}

static int sbr_8_cc_0_tmp_9 (void) {
  return (bdd_op_inputs[5] || sbr_8_cc_0_tmp_8 ());
}

static int sbr_8_cc_0_tmp_10 (void) {
  return (bdd_op_inputs[20] || sbr_8_cc_0_tmp_9 ());
}

static int sbr_8_cc_0_tmp_11 (void) {
  return (bdd_op_inputs[4] || sbr_8_cc_0_tmp_10 ());
}

static int sbr_8_cc_0_tmp_12 (void) {
  return (bdd_op_inputs[19] || sbr_8_cc_0_tmp_11 ());
}

static int sbr_8_cc_0_tmp_13 (void) {
  return (bdd_op_inputs[3] || sbr_8_cc_0_tmp_12 ());
}

static int sbr_8_cc_0_tmp_14 (void) {
  return (bdd_op_inputs[18] || sbr_8_cc_0_tmp_13 ());
}

static int sbr_8_cc_0_tmp_15 (void) {
  return (bdd_op_inputs[2] || sbr_8_cc_0_tmp_14 ());
}

static int sbr_8_cc_0_tmp_16 (void) {
  return (bdd_op_inputs[17] || sbr_8_cc_0_tmp_15 ());
}

static int sbr_8_cc_0_tmp_17 (void) {
  return (bdd_op_inputs[1] || sbr_8_cc_0_tmp_16 ());
}

struct mem_loc_t bdd_bitbit_sbr_cc (struct mem_loc_t in1, data_val_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2, bdd_op_inputs, 2 * 8);
  explode (0xff, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = 0;
  // bitbit_03_0_8.bdd
  outputs[3] = sbr_8_cc_0_tmp_1 ();
  // bitbit_04_0_8.bdd
  outputs[4] = 0;
  // bitbit_05_0_8.bdd
  outputs[5] = sbr_8_cc_0_tmp_1 ();
  // bitbit_06_0_8.bdd
  outputs[6] = (bdd_op_inputs[0]?0:(bdd_op_inputs[8] && (bdd_op_inputs[16]?0:(bdd_op_inputs[24] && (bdd_op_inputs[1]?0:(bdd_op_inputs[9] && (bdd_op_inputs[17]?0:(bdd_op_inputs[25] && (bdd_op_inputs[2]?0:(bdd_op_inputs[10] && (bdd_op_inputs[18]?0:(bdd_op_inputs[26] && (bdd_op_inputs[3]?0:(bdd_op_inputs[11] && (bdd_op_inputs[19]?0:(bdd_op_inputs[27] && (bdd_op_inputs[4]?0:(bdd_op_inputs[12] && (bdd_op_inputs[20]?0:(bdd_op_inputs[28] && (bdd_op_inputs[5]?0:(bdd_op_inputs[13] && (bdd_op_inputs[21]?0:(bdd_op_inputs[29] && (bdd_op_inputs[6]?0:(bdd_op_inputs[14] && (bdd_op_inputs[22]?0:(bdd_op_inputs[30] && (bdd_op_inputs[7]?0:(bdd_op_inputs[15] && (bdd_op_inputs[23]?0:sbr_8_cc_0_tmp_2 ())))))))))))))))))))))))))))))));
  // bitbit_07_0_8.bdd
  outputs[7] = 0;
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = 1;
  // bitbit_11_0_8.bdd
  outputs[11] = sbr_8_cc_0_tmp_3 ();
  // bitbit_12_0_8.bdd
  outputs[12] = 1;
  // bitbit_13_0_8.bdd
  outputs[13] = sbr_8_cc_0_tmp_3 ();
  // bitbit_14_0_8.bdd
  outputs[14] = (bdd_op_inputs[0] || (bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?(bdd_op_inputs[1] || (bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?(bdd_op_inputs[2] || (bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?(bdd_op_inputs[3] || (bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?(bdd_op_inputs[4] || (bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?(bdd_op_inputs[5] || (bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?(bdd_op_inputs[6] || (bdd_op_inputs[14]?(bdd_op_inputs[22] || (bdd_op_inputs[30]?(bdd_op_inputs[7] || (bdd_op_inputs[15]?sbr_8_cc_0_tmp_2 ():sbr_8_cc_0_tmp_4 ())):sbr_8_cc_0_tmp_5 ())):sbr_8_cc_0_tmp_6 ())):sbr_8_cc_0_tmp_7 ())):sbr_8_cc_0_tmp_8 ())):sbr_8_cc_0_tmp_9 ())):sbr_8_cc_0_tmp_10 ())):sbr_8_cc_0_tmp_11 ())):sbr_8_cc_0_tmp_12 ())):sbr_8_cc_0_tmp_13 ())):sbr_8_cc_0_tmp_14 ())):sbr_8_cc_0_tmp_15 ())):sbr_8_cc_0_tmp_16 ())):sbr_8_cc_0_tmp_17 ())):(bdd_op_inputs[16] || sbr_8_cc_0_tmp_17 ())));
  // bitbit_15_0_8.bdd
  outputs[15] = 1;
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}


#ifdef STACKTOOL
void bdd_bitbit_sbr (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 1
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_sbr_res (get_mem (m, dst_reg), imm, ccin);
    struct mem_loc_t cc  = bdd_bitbit_sbr_cc  (get_mem (m, dst_reg), imm, ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x1e);
  }
}
#endif
