#include "stacktool.h"
#include "bdd_bitbit_sen.h"

#include "../bdds/sen_8/cc/bitbit_8_funcs.ci"
struct mem_loc_t bdd_bitbit_sen_cc (struct mem_loc_t in1, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
#include "../bdds/sen_8/cc/bitbit_8_code.ci"
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}


#ifdef STACKTOOL
void bdd_bitbit_sen (struct memory *m)
{
  set_cc (m, bdd_bitbit_sen_cc (0x0);
}
#endif

